: <<charactersE.f>> ;
hex
1 gdi32 WINAPI: CreateSolidBrush
3 gdi32 WINAPI: CreatePen
4 gdi32 WINAPI: MoveToEx
9 gdi32 WINAPI: Arc
3 gdi32 WINAPI: Polygon
9 gdi32 WINAPI: Pie

$00FFFFFF CONSTANT WHITE
$000000FF CONSTANT LTRED
$0000FF00 CONSTANT LTGREEN
$00FF0000 CONSTANT LTBLUE
$0000007F CONSTANT RED
$00007F00 CONSTANT GREEN
$007F0000 CONSTANT BLUE
$0000FFFF CONSTANT LTYELLOW
$00FFFF00 CONSTANT LTCYAN
$00FF00FF CONSTANT LTMAGENTA
$00007F7F CONSTANT YELLOW
$007F7F00 CONSTANT CYAN
$007F007F CONSTANT MAGENTA
$00000000 CONSTANT BLACK
$007F7F7F CONSTANT GRAY

variable brush_color
variable pen_color

: set_brush_color ( color -- )
  MEMDC SWAP CreateSolidBrush SelectObject DROP
  ;

: set_pen_color ( color -- )
  0 0 ROT CreatePen
  MEMDC SWAP SelectObject DROP
  ;

: set_color ( color -- )
  dup set_brush_color set_pen_color
  ;

: ellipse ( x1 y1 x2 y2 -- ) 
  >R >R >R >R
  MEMDC R> R> R> R> Ellipse DROP
;

: circle ( x y r -- )
  >R PAD ! DUP R@ - SWAP R@ +
  PAD @ R@ - SWAP PAD @ R> +
  ellipse
  ;
  
: rectangle ( x1 y1 x2 y2 -- )
  >R >R >R >R
  MEMDC R> R> R> R> Rectangle DROP
;

: arc ( x1 y1 x2 y2 x3 y3 x4 y4 -- )
  >R >R >R >R >R >R >R >R
  MEMDC R> R> R> R> R> R> R> R> Arc DROP
;

: pie ( x1 y1 x2 y2 x3 y3 x4 y4 -- )
  >R >R >R >R >R >R >R >R
  MEMDC R> R> R> R> R> R> R> R> Pie DROP
;

: polygon ( a # -- )
  >R >R MEMDC R> R> Polygon DROP ;
  
: drawdemo 
  ltyellow set_brush_color
  red set_pen_color
  10 10 20 20 ellipse
  10 10 30 30 ellipse
  10 10 40 40 ellipse
  10 10 50 50 ellipse
  10 10 60 60 ellipse
  update
;

: moveto ( x y -- )
  >R >R 
  MEMDC R> R> 0 MoveToEx DROP
;

: lineto ( x y -- )
  >R >R
  MEMDC R> R> LineTo DROP
;

: linedemo
  green set_pen_color
  10 10 moveto
  10 60 lineto
  60 60 lineto
  60 10 lineto
  10 10 lineto
  update
  ;
  
\ ---------------------------------------------------------------
\ write characters
\ ---------------------------------------------------------------
hex
variable bit-originx
variable bit-originy
variable screen-width 
variable draw-state

create sun 8 C, 33 C, 0D3 C, 0DD C, 3D C, 33 C, 02 C, 38 C, 0D8 C,
create moon 0C C, 1F C, 3D C, 32 C, 0D2 C, 0DD C, 0CF C, 0AD C,
                02 C, 36 C, 0D6 C, 3A C, 0DA C,
create gold 10 C, 17 C, 81 C, F7 C, 02 C, 35 C, D5 C, 39 C, D9 C,
                1F C, 0FF C, 85 C, 8F C, 3B C, 7D C, 0DB C, 9D C,
create wood 8 C, 1E C, 86 C, 0FE C, 02 C, 16 C, 0F6 C, 81 C, 8F C,
create water 0C C, 81 C, 8D C, 7F C, 5C C, 01 C, 24 C, 77 C, 1E C,
                01 C, 0E4 C, 97 C, 0FE C,
create fire 0C C, 24 C, 87 C, 0E4 C, 01 C, 81 C, 89 C, 3E C, 1F C,
                01 C, 89 C, 0DE C, 0FF C,
create earth 7 C, 02 C, 27 C, 0E7 C, 1F C, 0FF C, 81 C, 8F C,

: get-screen-width
	hConsole @ PAD GetWindowRect DROP
	PAD CELL+ CELL+ @ PAD @ -
	screen-width !
	;
	
: byte-moveto ( byte -- )
        $10 /mod 0F and bit-originx @ + swap bit-originy @ +
        moveto ;

: byte-lineto ( byte -- )
        $10 /mod 0F and bit-originx @ + swap bit-originy @ +
        lineto ;

: new-char
        bit-originx @ $10 + bit-originx !
        ;

: new-line
        2 bit-originx !
        bit-originy @ $12 + bit-originy !
        ;

: new-page
        clearcanvas
       2 bit-originx !
        2 bit-originy !
        update
        ;

: draw-character ( addr -- )
        05 draw-state !
        0 0 moveto
        count for aft
                count
                dup 01 = if drop 5 draw-state ! else
                dup 02 = if drop 6 draw-state ! else
                draw-state @
                        dup 1 = if drop byte-lineto else
                        dup 2 = if drop byte-lineto 6 draw-state ! else
                        dup 5 = if drop byte-moveto 1 draw-state ! else
                        6 = if byte-moveto 2 draw-state ! then
                        then then then
                then then
        then next drop
        0 0 moveto
        new-char
        bit-originx @ screen-width @ <
        if else new-line then
        update
        ;

: demo1 new-page
	red set_pen_color
	get-screen-width
        sun draw-character
        moon draw-character
        gold draw-character
        wood draw-character
        water draw-character
        fire draw-character
        earth draw-character
        ;
decimal
: demo2
        new-page
        black set_pen_color
        ltblue set_brush_color
        0 0 500 600 rectangle
        ltred set_brush_color
        40 125 440 525 ellipse
        ltyellow set_brush_color
        190 225 290 425 ellipse
        ltgreen set_brush_color
        200 285 280 365 ellipse
        90 175 390 475 90 475 390 475 arc
        update
        ;

\ flags

create zordiac     120 , 260 , 33 , 110 , 207 , 110 ,
                120 , 60 , 33 , 210 , 207 , 210 ,
                220 , 160 , 70 , 73 , 70 , 247 ,
                20 , 160 , 170 , 73 , 170 , 247 ,

create star-data     -100 , 0 , -40 , 30 ,
                -31 , 95 , 15 , 46 ,
                81 , 59 , 50 , 0 ,
                81 , -59 , 15 , -46 ,
                -31 , -95 , -40 , -30 ,

create star-buf 80 allot

variable x
variable y
variable nominator
variable denominator
 	
: scale-star ( x y nominator denominator - )
	denominator ! nominator ! y ! x !
        star-data star-buf
        9 for over @ nominator @ denominator @ */
                x @ + over !
                over 4 + @ nominator @ denominator @ */
                y @ + over 4 + !
                8 8 d+
        next 2drop
        ;

: star ( x y nom denom color -- )
	set_color
        scale-star
        star-buf 10 polygon
        ;

: roc
        new-page
        0 0 476 646 ltred set_color rectangle
        0 0 240 320 ltblue set_color rectangle
        zordiac 3 white set_color polygon
        zordiac 24 + 3 white set_color polygon
        zordiac 48 + 3 white set_color polygon
        zordiac 72 + 3 white set_color polygon
        120 160 72 ltblue set_color circle
        120 160 65 white set_color circle
        update
        ;

: china
        new-page
        0 0 476 646 ltred set_color rectangle
        125 100 50 100 ltyellow star
        50 200 10 100 ltyellow star
        100 230 10 100 ltyellow star
        150 230 10 100 ltyellow star
        200 200 10 100 ltyellow star
        update
        ;

: usa
        new-page
        0 0 476 646 ltred set_color rectangle
        36 0 72 646 white set_color rectangle
        108 0 144 646 white set_color rectangle
        180 0 216 646 white set_color rectangle
        252 0 288 646 white set_color rectangle
        324 0 360 646 white set_color rectangle
        396 0 436 646 white set_color rectangle
        0 0 252 324 ltblue set_color rectangle
        27 27
        4 for   2dup
                5 for  2dup 15 100 white star
                        54 +
                next 2drop
                swap 50 + swap
        next 2drop
        52 54
        3 for   2dup
                4 for  2dup 15 100 white star
                        54 +
                next 2drop
                swap 50 + swap
        next 2drop
        update
        ;

: tao	new-page
	black set_pen_color
	white set_brush_color
	200 200 100 circle
	black set_brush_color
	100 100 300 300 200 100 200 300 pie
	200 150 50 circle
	white set_color
	200 249 49 circle
	200 150 20 circle
	black set_color
	200 250 20 circle
	update
	;
	
	