: <<dbg.f>> ; \ the step debuger 24feb02 ~ 04apr02 SamChen

create RegsDump $24 allot  here  constant RegsDumpLimit  MakeClink
variable theEDI  variable theESP

CODE SaveRegs ( -- )	\ save all registers and flags into RegsDump buffer
  push	edi			\ push edi to return stack
  mov	edi , esp		\ keep esp in edi
  lea	esp , RegsDumpLimit	\ let esp point to the end of RegsDump buffer
  pushad			\ push 8 32-bit registers into RegsDump buffer
  pushfd			\ push 32-bit flags into RegsDump buffer
  mov	esp , edi		\ recover old esp
  pop	edi			\ recover old edi
  mov	theEDI , edi	\ adjust RegsDump for real edi
  mov	theESP , esp	\ adjust RegsDump for real esp
  ret
  end-code

CODE LoadRegs ( -- )	\ load all registers and flags from RegsDump buffer
  push	edi			\ push edi to return stack
  mov	edi , esp		\ keep esp in edi
  lea	esp , RegsDump		\ let esp point to the top of RegsDump buffer
  popfd				\ pop flags from RegsDump buffer
  popad				\ pop registers from RegsDump buffer
  mov	esp , edi		\ recover old esp
  pop	edi			\ recover old edi
  ret
  end-code

  CREATE bp_image $90 ALLOT  bp_image 90 ERASE
  HERE CONSTANT bp_limit

  bp_image VALUE bp_entry

  DEFER (debug)
  variable prev_pc

: 1and.   ( v -- ) 1 and $30 + emit ;
: 8h. ( v -- ) <# # # # # # # # # #> type ;
: @.  ( a n -- a ) RegsDump + @ 8h. ;
: ShowRegs ( -- )
  cr cr
  ."  edi" theEDI @ 8h.
  ."  esi" $08 @.
  ."  ebp" $0C @.
  ."  esp" theESP @ 8h.
  RegsDump count ( a b )
  ."  c" dup 1and. cell/
  ."  p" dup 1and. cell/
  ."  a" dup 1and. cell/
  ."  z" dup 1and.    2/
  ."  s"     1and.
  cr  
  ."  edx" $18 @.
  ."  ecx" $1C @.
  ."  ebx" $14 @.
  ."  eax" $20 @.
  c@ ( b' )
  ."  t" dup 1and. 2/
  ."  i" dup 1and. 2/
  ."  d" dup 1and. 2/
  ."  o" dup 1and. 2/ cell/
  ."  n"     1and. ;

: clear_bp bp_image DUP ( p p ) DUP TO bp_entry
  BEGIN  ( p p' ) DUP @  ?DUP 
  WHILE  ( p p' a ) OVER CELL+ SWAP 5 ( p' p'+4 a 5 ) CMOVE 9 +
  REPEAT ( p p" ) OVER - ERASE ;

( : .s BASE @ >R HEX DEPTH DUP 0< 
  IF ." underflow, auto preset" PRESET 0
  THEN ?DUP
  IF 1-
     FOR R@ PICK n.
     NEXT
  ELSE ."  empty"
  THEN R> BASE ! ; )

: reset_bp clear_bp prev_pc @ ?dup
  if (debug)
  then ;

: step_debuger
  SaveRegs               \ save flags and registers into RegsDump buffer
  clear_bp               \ recOVER code image
  R> BODY>               \ get break point ( v1 v2 curr_pc )
  >R                     \ make sure current instruction be executed
  ShowRegs               \ show flags and registers
  CR .S R@ dis1          \ show data stack and current instruction
  next_pc !              \ save pc for next instruction
  BEGIN KEY DUP $1B =    \ see IF the key is ESC
     IF 0 indent ! ABORT" abort from dbg "
     THEN DUP BL =  
     OVER ASCII f = OR  OVER ASCII u = OR  OVER ASCII n = OR
     OVER ASCII F = OR  OVER ASCII U = OR  OVER ASCII N = OR  NOT
  WHILE CR .S DROP ." ? f=query u=unnest n=nest SPACE=next ESC=abort ELSE=help "
  REPEAT ( key )
  DUP ASCII f = OVER ASCII F = OR
  IF DROP $" dbg> "
     query_loop         \ get into query_execute loop
     LoadRegs
     EXIT
  THEN 
  DUP ASCII n = OVER ASCII N = OR \ nest into a word
  IF R@ C@  DUP $E8 =  SWAP $E9 =  branch_target @ branch_ca @ =  AND  OR
     \ make sure it's a call or last jump instruction
     IF 1 indent +!
        DROP R@
        @CurRelAddr   \ get the code address to call
        dup ['] <<extend.fex>> <
        IF drop next_pc @  \ for not nesting into primative core
        THEN (debug)
        LoadRegs
        EXIT
     THEN
  THEN 
  DUP ASCII u = OVER ASCII U = OR
  branch_target @ DUP branch_ca @ = AND OR
  R@ C@ $C3 =  OR     \ unnest to caller
  IF DROP indent @ 
     IF -1 indent +!
        RP@ CELL+ @   \ get address on return stack for returning to caller
       (debug)        \ unnest from curr word, return to caller
     THEN 
     LoadRegs
     EXIT        
  THEN                
  DROP                \ otherwise stepwise TO the next instruction
  branch_target @ ?DUP
  IF ( ... v2 v1 ta ) (debug) \ for branching to target address
  THEN ( ... v2 v1 )
  next_pc @ non_branch @ AND ?DUP
  IF (debug) \ for step debugging
  THEN r@ curr_pc ! 
  LoadRegs 
;

: set_breakpoint ( a -- ) \ set break point
  bp_entry DUP bp_limit < NOT ABORT" cannot set too many break points"
  2DUP ! ( a bpe ) 2DUP CELL+ 5 CMOVE ( a bpe ) $9 + TO bp_entry
  $E8 OVER C! ( a ) 1+ ( a+1 )
  ['] step_debuger OVER CELL+ - SWAP ! ;

' set_breakpoint IS (debug)

: debug ' set_breakpoint ; \ set break point at BEGINning of given word
: debug_next
  next_pc @ set_breakpoint ;

: dbg pad @ [ ' GPF >NAME ] LITERAL <>
  IF allInPad
  THEN ' dup code_start ! dup >name inPad nip 1+ pad@ cell- code_limit !
  DUP set_breakpoint EXECUTE ; \ debug the given word

: b next_pc       @ set_breakpoint ;
: t branch_target @ set_breakpoint ;

\ : xxx IF ." true" ELSE ." flase" THEN ;
\ 1 dbg xxx

only