        (
        FRAME
        *****
        PREVIOUSLY SCREEN ELEMENTS,
        NOW THE BASE CLASS OF ALL WIDGETS
        FOLLOW SYNTAX OF C :
        "->" POINT TO ADDRESS OF MEMBER ,
        "."  MEANS ACTUAL CONTENT OR METHOD.
        )
anew <<fwin.f>>

        0
        4 -- f->left
        4 -- f->top
        4 -- f->right
        4 -- f->bottom
        1 -- f->tag      \ type indentifier
        1 -- f->enabled
        1 -- f->selected
        1 -- f->visible
        4 -- f->parent   \ link to first children
        4 -- f->next     \ next on this level
        4 -- f->handler  \ event handler
        CONSTANT /FRAME

        (
        VIEW
        ****
        BASE ELEMENT FOR VISUAL
        WHEN A VIEW IS ADDED TO CONTAINER, IT MUST BE ALIGNED
        LEFT, TOP ,RIGHT OR BOTTOM.  DEFAULT IS aLEFT
        THE FREE REGION IS REDUCED AFTER A  VIEW IS ADDED.
        THE SIZE OF VIEW CAN BE MENTION BY % OR PX,
        % FOR PERCENTAGE OF FREE REGION, PX FOR ACTUAL PIXELS.
        )

        /FRAME
        4 -- v->ondraw
        4 -- v->textcolor
        4 -- v->textbg
        4 -- v->font
        4 -- v->pdata
        4 -- v->dsize
        4 -- v->var
        CONSTANT /VIEW

        (
        CONTAINER
        *********
        CONSIST VIEW OR OTHER CONTAINER.
        TEXT FORMATTER AND CONTAINER ARE DERIVED FROM VIEW,
        SO BE USED AS TABLE CELL
        )

        /VIEW
        4 -- c->child
        4 -- c->allocate
        4 -- c->startx
        4 -- c->starty
        4 -- c->endx
        4 -- c->endy
        4 -- c->alignment      \ where to place me ?
        4 -- c->newh           \ height to allocate
        4 -- c->neww           \ width  -''-
        4 -- c->fill
        4 -- c->viewx
        4 -- c->viewy
        CONSTANT /CTNR

        /CTNR
        4 -- t->xnow           \ current pen x position
        4 -- t->ynow           \ current pen y position
        4 -- t->lineheight     \ current line height
        4 -- t->linethick      \ current line thick        , horizonal: thick=height , vertical: thick = width
        4 -- t->maxlinethick   \ maximum thickness in this line
        4 -- t->PRE?           \ true if preformat
        4 -- t->SCATTER?       \ true if scatter text
        4 -- t->selstart       \ 0 means no selection
        4 -- t->selend         \ 0
        4 -- t->onselect
        4 -- t->bol            \ char at the end of this line
        4 -- t->orientation    \ 1 for vertical
        4 -- t->valignment
        4 -- t->first.aMIDDLE  \ set to max signed value
        4 -- t->first.aEND     \ beyond the last element
        CONSTANT /TXTS

\ *********


0 VALUE ffocus       \ keyboard message send to this frame
0 VALUE LASTF        \ newly created frame
0 VALUE MOUSE.X      \ client cordinate
0 VALUE MOUSE.Y      \ client cordinate
0 VALUE LOCAL.X
0 VALUE LOCAL.Y
0 VALUE MOUSE.KEY   
0 VALUE MOUSE?       \ true if mouse event
0 VALUE SCREEN       \ root container
0 VALUE 'c.alloc

\ : Overlap? { &r1 &r2 -- T|F }
\  &r1 rcRight  @     &r2 rcLeft   @ 1+ <
\  &r1 rcLeft   @ 1+  &r2 rcRight  @    > OR
\  &r1 rcBottom @     &r2 rcTop    @ 1+ < OR
\  &r1 rcTop    @ 1+  &r2 rcBottom @    > OR
\  0=
\  -> T|F
\ ;

: f.rect f->left ;

: inRect? { &rc x y -- T|F }
  x &rc rcLeft   @ >
  x &rc rcRight  @ < AND
  y &rc rcTop    @ > AND
  y &rc rcBottom @ < AND -> T|F 
;

\ read current Frame value
: F.tag    LASTF f->tag C@ ;
: F.left   LASTF f->left @ ;
: F.top    LASTF f->top @ ;
: F.right  LASTF f->right @ ;
: F.bottom LASTF f->bottom @ ;

  ( f -- )
: f.left    f->left   @ ;
: f.top     f->top    @ ;
: f.right   f->right  @ ;
: f.bottom  f->bottom @ ;
: f.next    f->next   @ ;
: f.width   DUP f.right  SWAP f.left - ;
: f.height  DUP f.bottom SWAP f.top  - ;
: f.parent  f->parent @ ;
: f.tag     f->tag C@ ;
: f.enabled f->enabled C@ ;
: f.visible f->visible C@ ;
: VISIBLE   1 SWAP f->visible C! ;
: INVISIBLE 0 SWAP f->visible C! ;
: ENABLE    1 SWAP f->enabled C! ;
: DISABLE   0 SWAP f->enabled C! ;
: f.selected f->selected C@ ;
: f.handler  f->handler  @ ;
: c.child   c->child  @ ;
: c.viewx c->viewx @ ;
: c.viewy c->viewy @ ;
 
\ all mouse event are direct to fcapture widget

8 CONSTANT MAXCAPTURE
CREATE CAPTURE-STK 0 , MAXCAPTURE 1- CELLS ALLOT
0 VALUE #capture

: &fcapture CAPTURE-STK #capture CELLS + ;
: fcapture &fcapture @ ;

: CAPTURE ( f -- ) #capture MAXCAPTURE < IF #capture 1+ TO #capture &fcapture ! ELSE DROP THEN ;
: RELEASE ( -- )   #capture 0 > IF #capture 1- TO #capture THEN ;

: init.capture
        CAPTURE-STK MAXCAPTURE 1- CELLS ERASE
        0 TO #capture
        ;

8 CONSTANT MAXPOPUP
CREATE POPUP-STK 0 , MAXPOPUP 1- CELLS ALLOT
0 VALUE #popup

: init.popup
        POPUP-STK  MAXPOPUP 1- CELLS ERASE
        0 TO #popup
        ;

: &fpopup POPUP-STK #popup CELLS + ;
: fpopup &fpopup @ ;

: +POPUP ( f -- ) #popup MAXPOPUP < IF #popup 1+ TO #popup &fpopup ! ELSE DROP THEN ;
: -POPUP ( -- )   #popup 0 > IF #popup 1- TO #popup THEN ;

: NOTICE ( lp wp msg f -- w )
\ dbg::evt   ." Notice! "  DUP h. DUP f->handler @ WordByAddr TYPE CR 
        DUP f->handler @ ?DUP IF EXECUTE THEN
        ;

: ToSCREEN { f \ x y -- x1 y1 }
  	0 -> x 0 -> y
  	BEGIN   f  
	WHILE	f f.left += x
    		f f.top  += y
    		f f.parent  -> f
  	REPEAT
  	x -> x1 y -> y1
	;

0 VALUE updateregion \ vector for update region
/RECT OBJECT_HA updaterc

: UPDATEREGION ( rc -- )  updateregion EXECUTE ;

\ relative from x y
: f.relupdate { f x y -- }
  	f f->left updaterc $10 CMOVE
  	updaterc x OVER +!
  	CELL+    y OVER +!
  	CELL+    x OVER +!
  	CELL+    y SWAP +!
  	updaterc UPDATEREGION
	;

: f.update { f \ p x y -- }
  	f ToSCREEN -> y -> x
\ 	" x= {#x}; y= {#y} " STYPE CR
  	f f.parent -> p
  	p ?DUP IF DUP c.viewx NEGATE += x
	c.viewy NEGATE += y
	THEN
  	updaterc x              OVER !
  	CELL+    y              OVER !
  	CELL+    x f f.width  + OVER !
  	CELL+    y f f.height + SWAP !
  	updaterc UPDATEREGION
	;

: ->xy  ( lp -- x y )   DUP $FFFF AND SWAP $10 RSHIFT  ;

: ClientMOUSE { f lp \ x y --  }
  	MOUSE? IF
  		f ToSCREEN -> y -> x
      		lp ->xy y - TO MOUSE.Y
              	x - TO MOUSE.X
  	THEN
	;

: mouseinrange? { f -- T|F }
  	MOUSE? IF 
    		f f.rect MOUSE.X MOUSE.Y 
		inRect? 0=    \ for mouse event , process only in my region
  	ELSE DROP 0 
	THEN
  	0= -> T|F
	;

: Overlap? { rc f \ l t -- T|F }
 	rc rcRight  @     LOCAL.X 1+           <
 	rc rcLeft   @ 1+  LOCAL.X f f.width +  > OR
 	rc rcBottom @     LOCAL.Y 1+           < OR
 	rc rcTop    @ 1+  LOCAL.Y f f.height + > OR
 	0=
  	-> T|F
 	;

: ?EXECUTE  ?DUP IF EXECUTE THEN ;

: f.setpos ( x1 y1 x2 y2 f -- )
  	>R
  	R@ f->bottom !
  	R@ f->right  !
  	R@ f->top    !
  	R> f->left   !
	;

: SETFOCUS ( f -- )
  	ffocus IF ffocus f.update THEN
  	DUP TO ffocus f.update
	;

$10 CONSTANT MAXCONTAINER
CREATE containers MAXCONTAINER CELLS ALLOT       \ stack for containers
-1 VALUE #container

: LASTC ( -- f )  containers #container CELLS + @ ;  \ the newly created container

: init.containers
        containers MAXCONTAINER CELLS ERASE
        -1 TO #container
        ;

: f.sethandler ( newhandler f -- ) f->handler ! ;
: F.sethandler   ( newhandler -- )   LASTF f.sethandler ;
: C.sethandler  ( newhandler -- )   LASTC f.sethandler ;

: FRAME { \ w -- }
\ dbg::view  HERE h.       ."      <- FRAME  "  CR  
  HERE -> w  /FRAME ALLOT
\  0 2DUP 2DUP w f.setpos
( ~kang) 0 0 0 0 w f.setpos
  0 w f->next !
  LASTC w f->parent !
  0 w f->tag C!
  1 w f->visible C!
  1 w f->enabled C!
  0 w f->selected C!
  LASTF SCREEN < LASTF 0 > AND IF
    ." error LASTF" LASTF .
  THEN
  LASTF IF 
    w LASTF   f->next !      \ continue 
  ELSE 
    #container -1 > IF w LASTC c->child ! THEN     \ first child of parent
  THEN
  w TO LASTF
  0 F.sethandler
  'c.alloc EXECUTE  \ call container to do allocation
;

: doText { str -- str' }
  str 2+ -> str'
;

: USEARCH1 ( c-addr u char -- pos t/f, searching ">" )
	SWAP 2/ ( length u to character count )
	FOR AFT	( 0 ?DO )
		OVER W@ OVER = ( compare one unicode character )
		IF R> 2DROP CELL+ -1 EXIT THEN
		SWAP 2+ SWAP
	THEN NEXT ( LOOP )
	0 ;

: USEARCH2 ( c-addr u char -- pos t/f, searching ">>" )
	DUP $10 LSHIFT + ( two unicode characters )
	SWAP 2/ 
	FOR AFT	( 0 ?DO )
		OVER @ OVER = ( compare two unicode character )
		IF R> 2DROP 2+ -1 EXIT THEN
		SWAP 2+ SWAP
	THEN NEXT ( LOOP )
	0 ;

: UNICODE> ( c-addr u -- c-addr u/2 )
	2/ >R ( count )
	DUP R@
	FOR AFT	( 0 ?DO )
		OVER W@ OVER C!
		1+ SWAP 2+ SWAP
	THEN NEXT ( LOOP )
	2DROP PAD R>
	;

: >UNICODE ( c-addr u -- c-addr u*2 )
	>R ( count )
	PAD R@
	FOR AFT	( 0 ?DO )
		OVER C@ OVER W!
		2+ SWAP 1+ SWAP
	THEN NEXT ( LOOP )
	2DROP 
	PAD R> 2* 
	;

: doTag ( a -- a' )
        DUP W@ [CHAR] < =
        IF  \ double tagstart and tagstop << >>
                DUP ( a -- )
                $800 [CHAR] > USEARCH2 
		IF ELSE 2DROP $" Missing >> error" THROW THEN
                2DUP SWAP - SWAP CELL+
        ELSE \ single < >
                DUP ( a -- )
                $800 [CHAR] > USEARCH1 
		IF ELSE 2DROP $" Missing > error" THROW THEN
                2DUP SWAP - SWAP 2+
        THEN  ( a tsize a+ -- )
        >R
        ( a tsize )  UNICODE>
        2DUP >R >R
        ['] EVAL CATCH
        IF      CR ." Eval tag error: " . CR
                R> R> TYPE CR
        ELSE R> R> 2DROP THEN
        R>
        ;

' doTag  VALUE onTag

CREATE ontexthandlers MAXCONTAINER CELLS ALLOT
-1 VALUE #ontexthandlers

: init.ontexthandlers
        ontexthandlers MAXCONTAINER CELLS ERASE
        -1 TO #ontexthandlers
        ;

: onText ( -- a )  ontexthandlers #ontexthandlers CELLS + ;

: PUSHonText ( h -- )
  #ontexthandlers MAXCONTAINER 1- > IF DROP EXIT THEN
  #ontexthandlers 1+ TO #ontexthandlers 
  onText !
;

: POPonText  #ontexthandlers 0 > IF #ontexthandlers 1- TO #ontexthandlers THEN ;

\ the default handler , just skip text
' doText PUSHonText

: formatbuffer { buf -- }                    \ construct screen element from buffer
  DECIMAL
  BEGIN buf W@ DUP WHILE
    [CHAR] < =
    IF   buf 2+ onTag  EXECUTE -> buf
    ELSE buf onText @ EXECUTE -> buf THEN
  REPEAT
;

: FreeFML ( cfa -- )
  EXECUTE 
  HERE CELL - @ TO LASTF -4 ALLOT  \ restore
  HERE CELL - @ TO #container -4 ALLOT 
;

: FMLLOAD ( cstr -- )
  LoadFile ?DUP IF formatbuffer THEN
;

\ 0 VALUE t1
: FML  ( -"name"- )  \ create header
\        GetTickCount TO t1
        >IN @ BL WORD DUP eFMLfile OVER C@ 1+ CMOVE
        FIND ?DUP AND IF FreeFML THEN
        >IN !
        #container ,
        LASTF ,
\        MARKER
        \ now load the file
        eFMLfile FMLLOAD
\ dbg::fml  GetTickCount t1 - ." Loading time " . CR CR CR  
        ;
